using System;
using System.Collections;
namespace HTMLParser
{
	/// <summary>
	/// 
	/// </summary>
	public class HTMLDocument
	{
		string html;
		public Node tree;
		
		public HTMLDocument(string html)
		{
            this.html = html;
			parse();		
		}

		private void parse()
		{
			ArrayList list = new ArrayList();
			int p = 0;


			// Parse it into a linear list of text and tags
			#region ParseToList
			while(p < html.Length)
			{
				while((p < html.Length) && char.IsWhiteSpace(html[p])) p++;

				if(p >= html.Length) break;

				if(html[p] == '<')
				{
					#region ParseTag
					// This is a tag
					p++;
					while(html[p] == ' ') p++;
					bool isEndTag = false;
					// TODO: parse comments for other info
					if(html[p] == '!') // This is a comment
					{
						while(html[p] != '>') p++;
						p++;
						continue;
					}
					if(html[p] == '/')
					{
						p++;
						isEndTag = true;
					}

					int sp = p;
					
					while((html[p] != ' ') && (html[p] != '>')) p++;
					string tagname = html.Substring(sp, p - sp);
					string tagparm = "";
					if(html[p] != '>')
					{
						sp = ++p;

						while(html[p] != '>') p++;

						tagparm = html.Substring(sp, p - sp);
					}

					p++;

					list.Add(Node.MakeTag(tagname, tagparm, isEndTag));
					#endregion
                    
				} 
				else 
				{
					#region ParseText
					
					// This is text

					p--;
					while(char.IsWhiteSpace(html[p])) p--;
					p++;

					int sp = p;
					while(html[p] != '<') p++;
					string text = html.Substring(sp, p - sp);

					list.Add(Node.MakeText(text));
					#endregion

				}
				
			}

			#endregion

			// Parse the list into a tree

			// We start with the root node
			tree = Node.MakeTag("root", "", false);

			tree.SubNodes = list;

			tree.MakeTree();




		}
	}
}
