using System;
using System.IO;

namespace HTMLParser
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			if(args.Length != 1)
			{
				System.Console.Out.Write("Usage: HTMLParser [filespec]\n\n");
				return;
			}

			string[] files = null;

			if(System.IO.File.Exists(args[0]))
			{
				files = new string[]{args[0]};
			}
			else
			{
				files = System.IO.Directory.GetFiles(System.IO.Directory.GetCurrentDirectory(), args[0]);
			}
			

			for(int i = 0; i < files.Length; i++)
			{
				StreamReader f = System.IO.File.OpenText(files[i]);
				String t = f.ReadToEnd();
				f.Close();

				StreamWriter ofile = System.IO.File.CreateText(files[i]);
			

				HTMLDocument doc = new HTMLDocument(t);

				Node n = doc.tree;

			
				//display(n, "", ofile);

				displayCondensed(n, ofile);
			
				ofile.Close();
			}
			//System.Console.In.Read(new char[1], 0, 1);
		}

		static void display(Node n, string s, StreamWriter ofile)
		{
			for(int i=0; i < n.SubNodes.Count; i++)
			{
				Node cur = ((Node)(n.SubNodes[i]));
				if(cur.Type == Node.TAGTYPE)
				{									
					ofile.WriteLine(s + "<" + cur.Tag + cur.ParamString + ">");
				} 
				else 
				{
					ofile.WriteLine(" " + s + cur.Text);
				}
				display(cur, s + " ", ofile);
				if(cur.Type == Node.TAGTYPE)
				{
					ofile.WriteLine(s + "</" + cur.Tag + ">");
				}
			}
		}

		static void displayCondensed(Node n, StreamWriter ofile)
		{
			for(int i=0; i < n.SubNodes.Count; i++)
			{
				Node cur = ((Node)(n.SubNodes[i]));
				if(cur.Type == Node.TAGTYPE)
				{									
					ofile.Write("<" + cur.Tag + cur.ParamString + ">");
				} 
				else 
				{
					ofile.Write(cur.Text);
				}
				displayCondensed(cur, ofile);
				if(cur.Type == Node.TAGTYPE)
				{
					ofile.Write("</" + cur.Tag + ">");
				}
			}
		}
	}
}
